/*
 * Abstract.cpp:
 *
 * This file defines functions that are implemented differently between
 * Win32 and Win16, ie., it abstracts them.
 *
 * Copyright (c) Malcolm Smith 2001-2002.  No warranty is provided.
 */

#include "pch.h"

#ifdef WIN3X_BASEAPI //WIN16
 
HANDLE pi_findfirst(LPSTR szFile,struct pi_find * fileinfo)
{                                                       
	int ret;
	ret=_dos_findfirst(szFile,0x00ff,fileinfo);
	if (ret) {
		return(INVALID_FIND_VALUE);
	} else {
		return NULL;
	}
}                                      

HANDLE pi_findnext(HANDLE hFind,struct pi_find * fileinfo)
{ 
	int ret;
	ret=_dos_findnext(fileinfo);
	if (ret) {
		return INVALID_FIND_VALUE;
	} else {
		return NULL;
	}
}   

int pi_findclose(HANDLE hFind)
{
	return TRUE;
}
unsigned int getAttr(pi_find * fileinfo)
{
	return(fileinfo->attrib);
}

char * getName(pi_find * fileinfo)
{
	return(fileinfo->name);
}


#else //WIN32

HANDLE pi_findfirst(LPSTR szFile,pi_find * fileinfo)
{
	HANDLE ret;
	ret=FindFirstFile(szFile,fileinfo);
	if (ret==INVALID_HANDLE_VALUE) {
		return INVALID_FIND_VALUE;
	} else {
		return ret;
	}
}

HANDLE pi_findnext(HANDLE hFind,pi_find * fileinfo)
{
	BOOL ret;
	ret=FindNextFile(hFind,fileinfo);
	if (!ret) {
		return INVALID_FIND_VALUE;
	} else {
		return NULL;
	}
}

BOOL pi_findclose(HANDLE hFind)
{
	return FindClose(hFind);
}

unsigned int getAttr(pi_find * fileinfo)
{
	return(fileinfo->dwFileAttributes);
}

char * getName(pi_find * fileinfo)
{
	return(fileinfo->cFileName);
}


#endif          
