/*
 * App.cpp
 *
 * This file takes care of launching the App and processing its core messages,
 * and some interface work.
 *
 * Copyright (c) Malcolm Smith 2001-2006.  No warranty is provided.
 */

#include "pch.h"

#define PTR_SIZE 32
#define MARGIN 0
DWORD dwPtrHeight;

HINSTANCE_T hInst;
HWND hWndMain;
HWND hWndCli;
HWND hWndPtr;
HWND hWndStatus;

BOOL LoadAPP()
{
  return TRUE;
}

BOOL IsTracker()
{
	return dwPtrHeight?TRUE:FALSE;
}

HWND InitInstance(HINSTANCE_T hInstance,int nCmdShow)
{
	int aWidths[3]={54,108,-1};
	HFONT hFont;
	hInst = hInstance;  
#ifndef WIN3X_CONTROLS
	InitCommonControls();
#else
#ifndef WS_EX_CLIENTEDGE
#define WS_EX_CLIENTEDGE NULL
#endif
#endif
	hWndMain=CreateWindowEx(
		0,
		"MalxMediaPlayer",
		product,
		WS_OVERLAPPEDWINDOW|WS_VISIBLE,
		GetSystemMetrics(SM_CXSCREEN)-200,
		0,
		200,
		250,
		(HWND)NULL,
		(HMENU)NULL,
		(HINSTANCE_T)hInstance,
		(LPVOID)NULL
	);
	hWndCli=CreateWindowEx(
#ifndef WIN3X_CONTROLS
		WS_EX_CLIENTEDGE,
#else
		0,
#endif
		"LISTBOX",
		"",
		WS_CHILD|WS_VISIBLE|WS_VSCROLL|LBS_NOINTEGRALHEIGHT|LBS_NOTIFY,
		0,0,32,32,
		(HWND)hWndMain,
		(HMENU)NULL,
		(HINSTANCE_T)hInstance,
		NULL
	);
#ifndef WIN3X_CONTROLS
	hWndPtr=CreateWindowEx(
		0,
		TRACKBAR_CLASS,
		"",
		WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS|TBS_TOP,
		0,MARGIN,32,dwPtrHeight,
		(HWND)hWndMain,
		(HMENU)NULL,
		(HINSTANCE_T)hInstance,
		(LPVOID)NULL);
	hWndStatus=CreateWindowEx(
		0,
		STATUSCLASSNAME,
		"",
		WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
		0,2*MARGIN,100,20,
		(HWND)hWndMain,
		(HMENU)NULL,
		(HINSTANCE_T)hInstance,
		(LPVOID)NULL);
	SendMessage(hWndStatus,SB_SETPARTS,3,(LPARAM)aWidths);
#endif


	HDC hDC;
	hDC=GetDC(hWndCli);
	hFont=CreateFont(-MulDiv(8, GetDeviceCaps(hDC, LOGPIXELSY), 72),0,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,"MS Sans Serif");
	ReleaseDC(hWndCli,hDC);
	SendMessage(hWndCli,WM_SETFONT,(WPARAM)hFont,MAKELPARAM(TRUE,0));

	RECT Rect;
	GetClientRect(hWndMain,&Rect);

	SendMessage(hWndMain,WM_SIZE,0,MAKELPARAM(Rect.right,Rect.bottom));

	return hWndMain;
}

BOOL CloseApp()
{
	return TRUE;
}

BOOL ProcessCmd(LPSTR lpCmdLine)
{
	PostMessage(GethWndMain(),C_WM_CMDLINE,0,(LPARAM)lpCmdLine);
	return TRUE;
}

BOOL InitApplication(HINSTANCE_T hInstance)
{
	WNDCLASS  wc;
	wc.style = 0;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hIcon = LoadIcon(hInstance,"ZAPPICON");
	wc.hInstance = hInstance;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName =  "dbMenu";
	wc.lpszClassName = "MalxMediaPlayer";
	return RegisterClass(&wc);
}


int WINAPI WinMain(HINSTANCE_T hInstance,HINSTANCE_T hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	MSG msg;
	HWND hWnd;
	HACCEL acctable;
#ifdef WIN3X_CONTROLS
	dwPtrHeight=0;
#else
	dwPtrHeight=PTR_SIZE;
#endif
#if 0
	hWnd=FindWindow("MalxMediaPlayer",NULL);
	if (hWnd) {
		ShowWindow(hWnd,SW_SHOW);
		return FALSE;
	}
#endif
	
	srand((UINT)(time(NULL)/256^(sizeof(time_t)-sizeof(UINT))));
	if (!InitApplication(hInstance)) return FALSE;
	if (!InitInstance(hInstance, nCmdShow)) return FALSE;
	acctable=LoadAccelerators(hInstance,"KEYS");
	hWnd=hWndMain;
	ShowWindow(hWndMain, nCmdShow);
	UpdateWindow(hWndMain);
	SendMessage(hWndMain,C_WM_REALBEGIN,0,0);
	ProcessCmd(lpCmdLine);	
	while (GetMessage(&msg,NULL,0,0)) {
		if (!TranslateAccelerator(hWnd,acctable,&msg)) {
			TranslateMessage(&msg);
		}
		DispatchMessage(&msg);
	}
	return EXIT_SUCCESS;
}



HINSTANCE_T GethInst()
{
	return hInst;
}

HWND GethWndMain()
{
	return hWndMain;
}

HWND GethWndCli()
{
	return hWndCli;
}

HWND GethWndPtr()
{
	return hWndPtr;
}

HWND GethWndStatus()
{
	return hWndStatus;
}

BOOL DispWindow(HWND hWnd,BOOL bDisp)
{
#ifndef WIN3X_CONTROLS
	if (bDisp) {
		ShowWindow(hWnd,SW_SHOWNORMAL);
		if (IsPlaying()&&IsTracker())
			SetTimer(hWnd,TIMER_ID,TIMER_TICK,NULL);
		SetForegroundWindow(hWnd);
	} else {
		ShowWindow(hWnd,SW_HIDE);
		KillTimer(hWnd,TIMER_ID);
	}
#endif
	return TRUE;
}



#ifndef WIN3X_CONTROLS

HMENU BuildPopupMenu(HWND hWnd)
{
	HMENU hTmp;
	BOOL bResumable;
	hTmp = CreatePopupMenu();
	if (hTmp == NULL) return NULL;

	bResumable = FALSE;

	if (GetMenuState(GetMenu(hWnd), IDM_PAUSE, MF_BYCOMMAND) & MF_GRAYED) bResumable = TRUE;

	AppendMenu(hTmp, MF_STRING, IDM_PLAY, "&Play");
	AppendMenu(hTmp, MF_STRING, IDM_STOP, "&Stop");
	if (bResumable) {
		AppendMenu(hTmp, MF_STRING | MF_GRAYED, IDM_PAUSE, "P&ause");
		AppendMenu(hTmp, MF_STRING, IDM_RESUME, "&Resume");
	} else {
		AppendMenu(hTmp, MF_STRING, IDM_PAUSE, "P&ause");
		AppendMenu(hTmp, MF_STRING | MF_GRAYED, IDM_RESUME, "&Resume");
	}
	AppendMenu(hTmp, MF_SEPARATOR, 0, NULL);
	AppendMenu(hTmp, MF_STRING, IDM_NEXT, "&Next");
	AppendMenu(hTmp, MF_STRING, IDM_PREVIOUS, "Pr&evious");
	AppendMenu(hTmp, MF_SEPARATOR, 0, NULL);
	AppendMenu(hTmp, MF_STRING, IDM_EXIT, "E&xit");

	return hTmp;
}

void TrayCallback(HWND hWnd,WPARAM wParam,LPARAM lParam)
{
	if (wParam==TRAYICON) {
		if (lParam==WM_LBUTTONDBLCLK) {
			DispWindow(hWnd,TRUE);
		} else if (lParam==WM_RBUTTONDOWN) {
			BOOL bDispState = IsWindowVisible(hWnd);
			POINT cursorpos;
			HMENU hPopupMenu;
			hPopupMenu = BuildPopupMenu(hWnd);
			DispWindow(hWnd,TRUE);
			GetCursorPos(&cursorpos);
			TrackPopupMenu(hPopupMenu,
			               TPM_RIGHTALIGN|TPM_BOTTOMALIGN,
			               cursorpos.x, //X
			               cursorpos.y, //Y
			               0, //Reserved
			               hWnd,
			               NULL);
			if (!bDispState)
				DispWindow(hWnd,bDispState);
			DestroyMenu(hPopupMenu);
		}
	}
}
#endif

BOOL Setontop(HWND hWnd,BOOL bOnTop)
{
	if (bOnTop) {
		SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOREDRAW);
		CheckMenuItem(GetMenu(hWnd),IDM_ONTOP,MF_CHECKED);
	} else {
		SetWindowPos(hWnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOREDRAW);
		CheckMenuItem(GetMenu(hWnd),IDM_ONTOP,MF_UNCHECKED);
	}
	return TRUE;
}

int SetTracker(HWND hWnd,BOOL bDispTrack)
{
#ifndef WIN3X_CONTROLS
	RECT Rect;
	if (!bDispTrack) {
		dwPtrHeight=0;
		ShowWindow(GethWndPtr(),SW_HIDE);
		ShowWindow(GethWndStatus(),SW_HIDE);
		CheckMenuItem(GetMenu(hWnd),IDM_DISPTRACK,MF_UNCHECKED);
		if (IsPlaying())
			KillTimer(hWnd,TIMER_ID);
	} else {
		dwPtrHeight=PTR_SIZE;
		ShowWindow(GethWndPtr(),SW_SHOW);
		ShowWindow(GethWndStatus(),SW_SHOW);
		CheckMenuItem(GetMenu(hWnd),IDM_DISPTRACK,MF_CHECKED);
		if (IsPlaying())
			SetTimer(hWnd,TIMER_ID,TIMER_TICK,NULL);
	}
	GetClientRect(hWnd,&Rect);
	SendMessage(hWnd,WM_SIZE,0,MAKELPARAM(Rect.right,Rect.bottom));
#endif	
	return(TRUE);
}

int UpdatePauseStatus(HWND hWnd, BOOL bResumable)
{
	if (bResumable) {
		EnableMenuItem(GetMenu(hWnd),IDM_RESUME,MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd),IDM_PAUSE,MF_BYCOMMAND|MF_GRAYED);
	} else {
		EnableMenuItem(GetMenu(hWnd),IDM_RESUME,MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(GetMenu(hWnd),IDM_PAUSE,MF_BYCOMMAND|MF_ENABLED);
	}
	return 0;
}

LRESULT APIENTRY MainWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static LIST List;
	static DWORD dwFindFlags;
	static char szOpenFile[MAX_PATH];
	static char szFindText[256];
	static DWORD dwRepeat;
	static BOOL bFullPath;
	static BOOL bOnTop;
	char szTemp[MAX_PATH];

	switch (message) {
 	case WM_COMMAND:
#ifdef WIN3X_BASEAPI
		switch(HIWORD(lParam)) {
#else
		switch(HIWORD(wParam)) {
#endif
		case LBN_SELCANCEL:
			CloseStream(hWnd);
			break;

		case LBN_DBLCLK:
			int dwIndex;
			if ((dwIndex=GetSelFile(GethWndCli()))>=0) {
				playMP3File(hWnd,&List,dwIndex);
			}
			UpdatePauseStatus(hWnd, FALSE);
			break;
		}
		switch(LOWORD(wParam)) {
			/*************/
			/* FILE MENU */
			/*************/
			case IDM_NEW:
				strcpy(szOpenFile,"");
				RefreshTitle(szOpenFile);
				ClearList(&List);
				RefreshList(GethWndCli(),&List,bFullPath);
				break;
			case IDM_OPEN:
				strcpy(szTemp,"");
				if (GetaFile(szTemp,FALSE)) {
					LPSTR a;
					ClearList(&List);
					InputFile(&List,szTemp);
					RefreshList(GethWndCli(),&List,bFullPath);
					strcpy(szOpenFile,szTemp);
					strupr(szTemp);
					if (a=strrchr(szTemp,'.')) {
						if (strcmp(a+1,"M3U")) {
							strcpy(szOpenFile,"");
						}
					} else strcpy(szOpenFile,"");
					RefreshTitle(szOpenFile);
				}
				break;
			case IDM_SAVE:
				if (strlen(szOpenFile)) {
					WriteList(&List,szOpenFile,0);
				} else {
					MessageBeep(MB_ICONEXCLAMATION);
					MessageBox(hWnd,"There is currently no open file.",product,48);
				}
				break;

			case IDM_SAVEAS:
				strcpy(szTemp,"");
				if (GetaFile(szTemp,TRUE)) {
					strcpy(szOpenFile,szTemp);
					RefreshTitle(szOpenFile);
					WriteList(&List,szTemp,0);
				}
				break;

			case IDM_EXIT:
				DestroyWindow(hWnd);
				PostQuitMessage(0);
				break;
			case IDM_ABOUT:
				{
					char szText[256];
					sprintf(szText,"Malx %s, %lu.%lu.%lu."
#ifdef PRERELEASE
						" Prerelease build, built on %s."
#endif
						" (c) Copyright 2001-2006.  "
						"This software is licensed under the terms of the GNU Public License, "
						"version 2 or any later version.",
						product,
						((unsigned long)version&0xffff0000)/0x00010000,
						((unsigned long)version&0x0000ff00)/0x00000100,
						version&0x000000ff
#ifdef PRERELEASE
						, __DATE__
#endif
						);
					MessageBox(hWnd,szText,product,64);
					break;
				}
			/**************/
			/* MEDIA MENU */
			/**************/
			case IDM_PLAY:
				int dwIndex;
				if ((dwIndex=GetSelFile(GethWndCli()))>=0) {
					playMP3File(hWnd,&List,dwIndex);
				}
				UpdatePauseStatus(hWnd, FALSE);
				break;
			case IDM_STOP:
				CloseStream(hWnd);
				UpdatePauseStatus(hWnd, FALSE);
				break;
			case IDM_PAUSE:
				PauseAudio();
				UpdatePauseStatus(hWnd, TRUE);
				break;
			case IDM_RESUME:
				ResumeAudio();
				UpdatePauseStatus(hWnd, FALSE);
				break;

			case IDM_NEXT:
				playMP3File(hWnd,&List,-1);
				break;
			case IDM_PREVIOUS:
				playMP3File(hWnd,&List,-2);
				break;
			case IDM_FIRST:
				playMP3File(hWnd,&List,0);
				break;
			case IDM_LAST:
				playMP3File(hWnd,&List,(int)List.dwItemsInList-1);
				break;
			case IDM_REP_NEXTTRACK:
				dwRepeat=REPEAT_NEXTTRACK;
				CheckMenuItem(GetMenu(hWnd),IDM_REP_NEXTTRACK,MF_CHECKED);
				CheckMenuItem(GetMenu(hWnd),IDM_REP_THISTRACK,MF_UNCHECKED);
				CheckMenuItem(GetMenu(hWnd),IDM_REP_NOTRACK,MF_UNCHECKED);
				break;
			case IDM_REP_THISTRACK:
				dwRepeat=REPEAT_THISTRACK;
				CheckMenuItem(GetMenu(hWnd),IDM_REP_NEXTTRACK,MF_UNCHECKED);
				CheckMenuItem(GetMenu(hWnd),IDM_REP_THISTRACK,MF_CHECKED);
				CheckMenuItem(GetMenu(hWnd),IDM_REP_NOTRACK,MF_UNCHECKED);
				break;
			case IDM_REP_NOTRACK:
				CheckMenuItem(GetMenu(hWnd),IDM_REP_NEXTTRACK,MF_UNCHECKED);
				CheckMenuItem(GetMenu(hWnd),IDM_REP_THISTRACK,MF_UNCHECKED);
				CheckMenuItem(GetMenu(hWnd),IDM_REP_NOTRACK,MF_CHECKED);
				dwRepeat=REPEAT_NOTRACK;
				break;
			/**************/
			/* Items Menu */
			/**************/
			case IDM_SORTDISPLAY:
				SortList(&List,SORT_DISPLAY);
				RefreshList(GethWndCli(),&List,bFullPath);
				break;

			case IDM_SORTFILE:
				SortList(&List,SORT_FILE);
				RefreshList(GethWndCli(),&List,bFullPath);
				break;
			case IDM_SORTPATH:
				SortList(&List,SORT_PATH);
				RefreshList(GethWndCli(),&List,bFullPath);
				break;

			case IDM_SHUFFLE:
				ShuffleList(&List);
				RefreshList(GethWndCli(),&List,bFullPath);
				break;
			case IDM_MOVEUP:
				{
					DWORD i;
					i=(DWORD)SendMessage(GethWndCli(),LB_GETCURSEL,0,0);
					if (i>0) {
						SwapListItems(&List, i, i-1);
						if (SendMessage(GethWndCli(),LB_GETTEXT,(WPARAM)i,(LPARAM)szTemp)) {
							SendMessage(GethWndCli(),LB_DELETESTRING,(WPARAM)i,0);
							SendMessage(GethWndCli(),LB_INSERTSTRING,(WPARAM)i-1,(LPARAM)szTemp);
						} else {
							RefreshList(GethWndCli(),&List,bFullPath);
						}
						SendMessage(GethWndCli(),LB_SETCURSEL,(WPARAM)i-1,0);
					}
				}
				break;
			case IDM_MOVEDOWN:
				{
					DWORD i;
					i=(DWORD)SendMessage(GethWndCli(),LB_GETCURSEL,0,0);
					if (i>=0) {
						if (i<List.dwItemsInList-1) {
							SwapListItems(&List, i, i+1);
							if (SendMessage(GethWndCli(),LB_GETTEXT,(WPARAM)i,(LPARAM)szTemp)) {						
								SendMessage(GethWndCli(),LB_DELETESTRING,(WPARAM)i,0);
								SendMessage(GethWndCli(),LB_INSERTSTRING,(WPARAM)i+1,(LPARAM)szTemp);
							} else {
								RefreshList(GethWndCli(),&List,bFullPath);
							}
							SendMessage(GethWndCli(),LB_SETCURSEL,(WPARAM)i+1,0);
						}
					}
				}
				break;
			case IDM_DELETE:
				{
					DWORD i;
					i=(DWORD)SendMessage(GethWndCli(),LB_GETCURSEL,0,0);
					if (i>=0) {
						DeleteListItem(&List, i);
						SendMessage(GethWndCli(),LB_DELETESTRING,(WPARAM)i,0);
						if (i==List.dwItemsInList) i--;
						SendMessage(GethWndCli(),LB_SETCURSEL,(WPARAM)i,0);
						//RefreshList(GethWndCli(),List,ItemsInList,bFullPath);
					}
				}
				break;
			case IDM_DISPPATH:
				bFullPath=!bFullPath;
				RefreshList(GethWndCli(),&List,bFullPath);
				if (bFullPath) {
					CheckMenuItem(GetMenu(hWnd),IDM_DISPPATH,MF_CHECKED);
				} else {
					CheckMenuItem(GetMenu(hWnd),IDM_DISPPATH,MF_UNCHECKED);
				}
				break;
			case IDM_ONTOP:
				bOnTop=!bOnTop;
				Setontop(hWnd,bOnTop);
				break;
			case IDM_DISPTRACK:
				SetTracker(hWnd,!dwPtrHeight);
				break;
			case IDM_REFRESH:
				RefreshList(GethWndCli(),&List,bFullPath);
				break;
			case IDM_IMPORTFILE:
				strcpy(szTemp,"");
				if (GetaFile(szTemp,FALSE)) {
					InputFile(&List,szTemp);
					RefreshList(GethWndCli(),&List,bFullPath);
				}
				break;
			case IDM_FIND:
				if (FindEntry(szFindText,&dwFindFlags)) {
					int i;
					i=(int)SendMessage(GethWndCli(),LB_GETCURSEL,0,0);
					if (i==LB_ERR) i=0;
					i=FindNext(&List,i,szFindText,dwFindFlags);
					if (i>=0) {
						SendMessage(GethWndCli(),LB_SETCURSEL,i,0);
					} else {
						MessageBox(hWnd,"No matches found.",product,64);
					}
				}
				break;
			case IDM_FINDNEXT:
				{
					long i;
					i=(long)SendMessage(GethWndCli(),LB_GETCURSEL,(WPARAM)0,(LPARAM)0);
					if (i==LB_ERR) {
						i=0;
					} else {
						i++;
					}
					if (dwFindFlags&FIND_STARTTOP) dwFindFlags-=FIND_STARTTOP;
					i=FindNext(&List,i,szFindText,dwFindFlags);
					if (i>=0) {
						SendMessage(GethWndCli(),LB_SETCURSEL,(WPARAM)i,0);
					} else {
						MessageBox(hWnd,"No more matches found.",product,64);
					}
				}
				break;
			case IDM_STRIP:
				if (FindEntry(szFindText,&dwFindFlags)) {
					int i;
					i=(int)SendMessage(GethWndCli(),LB_GETCURSEL,0,0);
					if (i==LB_ERR) i=0;
					i=FindNext(&List,i,szFindText,dwFindFlags);
					while (i>=0) {
						DeleteListItem(&List, i);
						i--;
						if (i<0) i=0;
						i=FindNext(&List,i,szFindText,dwFindFlags);
					}
					RefreshList(GethWndCli(),&List,bFullPath);
				}
				break;
#ifdef INTERNAL
			case IDM_PROPERTIES:
				{
					LRESULT i;
					i=SendMessage(GethWndCli(),LB_GETCURSEL,0,0);
					if (i>=0) {
						DialogBoxParam(GethInst(),"IDDPROP",GethWndMain(),(DLGPROC)PropertiesDlgProc,(LPARAM)&GetListItem(&List, i));
					} else {
						MessageBox(hWnd,"Please select the track which you would like to obtain Properties for.",product,64);
					}
				}
				break;
#endif
			default:
				return DefWindowProc(hWnd, message, wParam, lParam);
				break;
			}
		break;
	case WM_CREATE:
		{
			bFullPath=FALSE;
			bOnTop=FALSE;
			dwRepeat=REPEAT_NEXTTRACK;
			strcpy(szOpenFile,"");
			strcpy(szFindText,"");
			dwFindFlags=0;
			ResetHandlers();
			AddHandler("mp3","MPEGVideo");
			InitList(&List);
			DragAcceptFiles(hWnd,TRUE);
#ifndef WIN3X_CONTROLS
			AddTrayIcon(hWnd);
#endif
		}

		break;
	case C_WM_REALBEGIN:
#if defined(SCRIPTING)&&(!defined(_CYGWIN))
		{
			char szTemp[512];
			_searchenv("default.msc","PATH",szTemp);
			if (szTemp&&strlen(szTemp)) {
				PlayScript(&List,szTemp);
				RefreshList(GethWndCli(),&List,bFullPath);
			}
		}
#endif
		break;
#ifdef WM_MOUSEWHEEL
	case WM_MOUSEWHEEL:
		PostMessage(GethWndCli(), WM_MOUSEWHEEL, wParam, lParam);
		break;
#endif
	case WM_DROPFILES:
		{
			DWORD i,nFiles;
			HDROP hDrop;
			HANDLE hFind;
			pi_find fd;
			hDrop=(HDROP)wParam;
#ifdef WIN3X_BASEAPI
			nFiles=DragQueryFile(hDrop,(signed)(-1),NULL,0);
#else
			nFiles=DragQueryFile(hDrop,0xffffffff,NULL,0);
#endif
			for (i=0;i<nFiles;i++) {
				DragQueryFile(hDrop,(int)i,szTemp,sizeof(szTemp));
				
				hFind=pi_findfirst(szTemp,&fd);
				pi_findclose(hFind);
				if (getAttr(&fd)&FA_SUBDIR) { 
					GenerateTree(&List,szTemp);
				} else { 
					InputFile(&List,szTemp);
				}
			}
			DragFinish(hDrop);
			RefreshList(GethWndCli(),&List,bFullPath);

		}
		break;
	case WM_CLOSE:
#if !defined(BROKEN_MINIMIZE) && !defined(WIN3X_CONTROLS)
		DispWindow(hWnd,FALSE);
#else
		DestroyWindow(hWnd);
		PostQuitMessage(0);
#endif
		break;
#ifndef WIN3X_CONTROLS
	case TRAY_CALLBACK:
		TrayCallback(hWnd,wParam,lParam);
		break;
#endif
	case WM_DESTROY:
		FreeList(&List);
		DelTrayIcon(hWnd);
		break;
	case MM_MCINOTIFY:
			if (wParam==MCI_NOTIFY_SUCCESSFUL) {
				switch(dwRepeat) {
				case REPEAT_NEXTTRACK:
					if (!playMP3File(hWnd,&List,-1)) {
						CloseStream(hWnd);
					}
					break;
				case REPEAT_THISTRACK:
					if (!playMP3File(hWnd,&List,-3)) {
						CloseStream(hWnd);
					}
					break;
				}
			}

		break;
	case C_WM_CMDLINE:
		{
			LPSTR a;
			HANDLE hFind;
			pi_find fd;
			a=(LPSTR)lParam;
			if (a[0]=='"') {
				strcpy(szTemp,a+1);
				a=strchr(szTemp,'"');
				if (a) a[0]='\0';
			} else {
				strcpy(szTemp,(LPSTR)lParam);
			}
			if ((hFind=pi_findfirst(szTemp,&fd))!=0) {
				if (szTemp&&strlen(szTemp)) {
					pi_findclose(hFind);
					if (getAttr(&fd)&FA_SUBDIR) {
						GenerateTree(&List,szTemp);
					} else {
						InputFile(&List,szTemp);
					}
					RefreshList(GethWndCli(),&List,bFullPath);
					playMP3File(hWnd,&List,0);
				}
			}
		}

		break;

	case WM_SIZE:
#ifdef BROKEN_MINIMIZE
		if (wParam==SIZEICONIC) {
			DispWindow(hWnd, FALSE);
		} else {
#endif
		if (dwPtrHeight) {
			RECT Rect;
			int WinHeight;
			GetWindowRect(GethWndStatus(),&Rect);
			WinHeight=Rect.bottom-Rect.top;
			MoveWindow(GethWndCli(),0,0,(int)LOWORD(lParam),(int)(HIWORD(lParam)-dwPtrHeight-WinHeight-2*MARGIN),TRUE);
			MoveWindow(GethWndPtr(),0,(int)(HIWORD(lParam)-dwPtrHeight-WinHeight-1*MARGIN),(int)LOWORD(lParam),(int)dwPtrHeight,TRUE);
			MoveWindow(GethWndStatus(),0,HIWORD(lParam)-WinHeight,LOWORD(lParam),WinHeight,TRUE);
			RedrawWindow(GethWndStatus(),NULL,NULL,RDW_ERASE|RDW_INVALIDATE);
		} else {
			MoveWindow(GethWndCli(),0,0,LOWORD(lParam),HIWORD(lParam),TRUE);
		}
#ifdef BROKEN_MINIMIZE
		}
#endif
		break;
	case WM_TIMER:
		if (dwPtrHeight)
			UpdatePos();
		break;
	case WM_HSCROLL:
#ifndef WIN3X_CONTROLS
		if (LOWORD(wParam)==TB_THUMBTRACK)
			KillTimer(hWnd,TIMER_ID);
#endif
		if (LOWORD(wParam)==SB_ENDSCROLL) {
			if (IsPlaying()&&IsTracker())
				SetTimer(hWnd,TIMER_ID,TIMER_TICK,NULL);
			SetAudioPos(hWnd);
		}

		break;
	default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return (0);
}
