
// Import.h

#ifdef WIN3X_BASEAPI
#include <malloc.h> 
#include <string.h>
#else
#include <io.h>
#endif

typedef struct {
    HANDLE hAlloc;
    LPSTR data;
} LISTENTRY;

typedef struct {
    HANDLE hAlloc;
    LISTENTRY * entrylist;
    DWORD dwItemsInList;
    DWORD dwItemsAllocated;
} LIST;

#define GetListItem(List, Item) ((List)->entrylist[Item].data)

#ifndef APIENTRY
#define APIENTRY PASCAL
#endif

LRESULT APIENTRY PropertiesDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
LRESULT APIENTRY MainWndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam);
LONG APIENTRY abCB(HWND hWnd,UINT message,UINT wParam,LONG lParam);

int CloseApp();                                       //APP.CPP
//int FillStatus(unsigned int);                         //INTER.CPP
HINSTANCE GethInst();                                 //APP.CPP
HWND GethWndCli();                                    //APP.CPP
HWND GethWndMain();                                   //APP.CPP
HWND GethWndStatus();                                 //APP.CPP
HWND GethWndPtr();
int SetActiveItem(DWORD dwNewItem);
int RefreshTitle(LPSTR szTitle);
int AddTrayIcon(HWND hWnd);
int DelTrayIcon(HWND hWnd);
int SetTrackerPos(DWORD dwValue);
int SetTrackerLength(DWORD dwValue);
int UpdatePos();
int SetAudioPos(HWND hWndNotify);
int GetTrackerPos();
int PauseAudio();
int ResumeAudio();
int SetOpenFile(LPSTR szFile);
int FindEntry(LPSTR szFindText,LPDWORD dwFlags);
LPSTR GetPtr(LPSTR szPath,DWORD dwTo);
BOOL IsTracker();
int IsPlaying();
int DispWindow(HWND hWnd,BOOL bDisp);

int ResetHandlers();
int AddHandler(LPSTR szExt,LPSTR szHandler);
LPSTR GetHandler(LPSTR szExt);
LPSTR EnumHandlerExtensions(LPSTR szBuffer,LPSTR szSep);
int Setontop(HWND hWnd,BOOL bOnTop);
int SetTracker(HWND hWnd,BOOL bDispTrack);


int ClearList(LIST * List);
int FreeList(LIST * List);
int InitList(LIST * List);
int InputFile(LIST * List,LPSTR szFile);
int RefreshList(HWND hWnd,LIST * List,BOOL bFullPath);
int ShuffleList(LIST * List);
int SortList(LIST * List,int iCriteria);
int WriteList(LIST * List,LPSTR szFile,DWORD dwItems);
int AddListItem(LIST * List,LPSTR szItem);
int GenerateTree(LIST * List,LPSTR szPath);
int FindNext(LIST * List,DWORD dwStart,LPSTR szText,DWORD dwFlags);
int SwapListItems(LIST * List, DWORD dwItem1, DWORD dwItem2);
int DeleteListItem(LIST * List, DWORD dwItem);



int GetaFile(LPSTR szFile,BOOL Save);
int GetSelFile(HWND hWnd);
int CloseStream(HWND hWnd);
int OpenStream(HWND hWnd,LPSTR szFile);

DWORD playMP3File(HWND hWndNotify, LIST * List,int dwNewIndex);

#ifdef SCRIPTING
int PlayScript(LIST * List,LPSTR szFile);
#endif 

/*Platform independence functions*/
#ifdef WIN3X_BASEAPI 
#define pi_find _find_t
#define HINSTANCE_T HANDLE
#define FA_SUBDIR _A_SUBDIR
#define INVALID_HANDLE_VALUE (HANDLE)-1
#else            
#define pi_find WIN32_FIND_DATA
#define HINSTANCE_T HINSTANCE

#define FA_SUBDIR FILE_ATTRIBUTE_DIRECTORY
#endif
#define INVALID_FIND_VALUE INVALID_HANDLE_VALUE
HANDLE pi_findfirst(LPSTR szFile,pi_find * fileinfo);
HANDLE pi_findnext(HANDLE hFind,pi_find * fileinfo);
BOOL   pi_findclose(HANDLE hFind);

unsigned int getAttr(pi_find *);
char *       getName(pi_find *);




#define TRAYICON 2000
#define TRAY_CALLBACK  (WM_USER+0x0200)
#define C_WM_CMDLINE   (WM_USER+0x0201)
#define C_WM_REALBEGIN (WM_USER+0x0202)

#define IDM_NEW                         101
#define IDM_OPEN                        102
#define IDM_SAVE                        103
#define IDM_SAVEAS                      104
#define IDM_EXIT                        111
#define IDM_ABOUT                       121

#define IDM_PLAY                        201
#define IDM_STOP                        202
#define IDM_PAUSE                       203
#define IDM_RESUME                      204
#define IDM_NEXT                        2111
#define IDM_PREVIOUS                    2112
#define IDM_FIRST                       2113
#define IDM_LAST                        2114
#define IDM_REP_NEXTTRACK               2121
#define IDM_REP_THISTRACK               2122
#define IDM_REP_NOTRACK                 2123



#define IDM_SORTDISPLAY                 3011
#define IDM_SORTFILE                    3012
#define IDM_SORTPATH                    3013
#define IDM_SHUFFLE                     3014
#define IDM_MOVEUP                      3021
#define IDM_MOVEDOWN                    3022
#define IDM_DELETE                      3023
#define IDM_FIND                        311
#define IDM_FINDNEXT                    312
#define IDM_STRIP                       313
#define IDM_DISPPATH                    3211
#define IDM_ONTOP                       3212
#define IDM_DISPTRACK                   3213
#define IDM_REFRESH                     331
#define IDM_IMPORTFILE                  332
#define IDM_PROPERTIES                  341

#define IDD_FIND                        5000
#define IDC_FINDTEXT                    5001
#define IDC_STARTTOP                    5010
#define IDC_MATCHCASE                   5011
#define IDC_SEARCHPATH                  5012
#define IDC_INVERT                      5013

#define IDD_PROPERTIES                  5100
#define IDC_TRACKNAME                   5101
#define IDC_ARTIST                      5102
#define IDC_SOURCE                      5103
#define IDC_SOURCETYPE                  5104
#define IDC_TRACK                       5105

#define TIMER_ID 1
#define TIMER_TICK 1000

#define SORT_PATH 0
#define SORT_FILE 1
#define SORT_DISPLAY 2

#define FIND_STARTTOP   0x00000001
#define FIND_MATCHCASE  0x00000002
#define FIND_INVERT     0x00000004
#define FIND_SEARCHMASK 0xffff0000
#define FIND_SEARCHDIV  0x00010000
#define FIND_SEARCHPATH 0x00000000
#define FIND_SEARCHFILE 0x00010000
#define FIND_SEARCHDISP 0x00020000

#define REPEAT_NEXTTRACK 0x00
#define REPEAT_THISTRACK 0x01
#define REPEAT_NOTRACK   0x02


#ifndef MAX_PATH
#define MAX_PATH 256
#endif
